
-- 252 rows affected, SRID 0
select geom.STSrid, * from cntry00;

-- 2606 rows affected, SRID 0
select geom.STSrid, * from admin00;

-- 3 rows
select * from cntry00
where geom.STIsValid() = 0;

-- 24411
select geom.IsValidDetailed(), * from cntry00
where geom.STIsValid() = 0;

-- 6 rows
select * from admin00
where geom.STIsValid() = 0;

-- 24411 amd 24410
select geom.IsValidDetailed(), * from admin00
where geom.STIsValid() = 0;

-- 142, 369, 493, 502, 694, 1484
update admin00
set geom = geom.MakeValid()
output inserted.id
where geom.STIsValid() = 0;

-- 21, 42, 252
update cntry00
set geom = geom.MakeValid()
output inserted.id
where geom.STIsValid() = 0;

-- remove constraints to enfore SRID 0, then...
update admin00
set geom.STSrid = 4326;
update cntry00
set geom.STSrid = 4326;

-- add geography column
alter table admin00 add geog geography;
alter table cntry00 add geog geography;

-- vacuous conversion to geography
update admin00
set geog = geography::STGeomFromWKB(geom.STAsBinary(), 4326)
update cntry00
set geog = geography::STGeomFromWKB(geom.STAsBinary(), 4326)

-- see why these are invalid now...
-- 24413, 24414 near the poles (3 rows)
select geog.IsValidDetailed(), * from cntry00
where geog.STIsValid() = 0;

-- 24413, 24414 near the poles (3 rows)
select geog.IsValidDetailed(), * from admin00
where geog.STIsValid() = 0;

-- validate again
-- 11,2363,2537
update admin00
set geog = geog.MakeValid()
output inserted.id
where geog.STIsValid() = 0;

-- 1,181,215
update cntry00
set geog = geog.MakeValid()
output inserted.id
where geog.STIsValid() = 0;

-- check for more than a hemisphere, none found
select * from admin00
where geog.EnvelopeAngle() > 90;
select * from cntry00
where geog.EnvelopeAngle() > 90;

select * from cntry00;

-- same this way, no rows
declare @h geography = 'FULLGLOBE';
declare @a float = @h.STArea() / 2;
select *, geog.STArea() as thearea from admin00
where geog.STArea() / @a > 1
go

declare @h geography = 'FULLGLOBE';
declare @a float = @h.STArea() / 2;
select *, geog.STArea() as thearea from cntry00
where geog.STArea() / @a > 1
go

