
-- 5. CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON spatial types
-- geometric semicircle
DECLARE @g geometry;
SET @g = geometry::Parse('COMPOUNDCURVE(CIRCULARSTRING(0 2, 2 0, 4 2), (4 2, 0 2))');
select @g;
select @g.STCurveToLine();
select @g.STNumPoints() as [CurvePoints], @g.STCurveToLine().STNumPoints() as [LinePoints] 
GO

-- geometric full circle 
DECLARE @g2 geometry;
SET @g2 = geometry::Parse('COMPOUNDCURVE(CIRCULARSTRING(0 2, 2 0, 4 2), CIRCULARSTRING(4 2, 2 4, 0 2))');
SELECT 'Circle Two', @g2.STLength() AS Perimeter; -- now we get an accurate amount
select @g2
select @g2.STCurveToLine();
select @g2.STNumPoints() as [CurvePoints], @g2.STCurveToLine().STNumPoints() as [LinePoints] 
GO  

-- Get earth's surface area
DECLARE @P GEOGRAPHY = GEOGRAPHY::STGeomFromText('CURVEPOLYGON 
  (CIRCULARSTRING 
    (  0 0, 
     -90 0, 
     180 0, 
      90 0, 
       0 0))', 4326);
SELECT @p.STIsValid();  -- Returns: 1 (valid)
SELECT @p.STArea();  -- area: 255032815307904
SELECT @P.STArea() * 2 AS WGS84_SURFACE_AREA -- 510065630615808 square meters
go