
declare @g1 geometry = 'POLYGON((0 0, 0 29.661245, 82.339026 29.661245, 82.339026 0, 0 0))'
declare @g2 geometry = 'POINT(0 0)'

-- on SQL Server pre-2012, this results in 
-- POLYGON ((0 0, 82.339025497436523 0, 82.339025497436523 29.661244869232178, 0 29.661244869232178, 0 0))
select @g1.STUnion(@g2).ToString();

-- persisted computed column of data type "UDT"
-- on SQL Server pre-2012, this produces error:
-- Msg 4994, Level 16, State 1, Line 1
-- Computed column 'ugeom' in table 't1' cannot be persisted because the column type, 'geometry', is a non-byte-ordered CLR type.
create table t1(
 id int identity primary key,
 geom geometry,
 ugeom as geom.STUnion('POINT(0 0)') persisted
)
go

-- SQL Server 2012: POLYGON ((0 0, 82.339026 0, 82.339026 29.661245, 0 29.661245, 0 0))
declare @g1 geometry = 'POLYGON((0 0,82.339026 0, 82.339026 29.661245, 0 29.661245, 0 0))'
declare @g2 geometry = 'POINT(0 0)'

select @g1.STUnion(@g2).ToString();

-- fits in persisted computed column
declare @g3 geometry = @g1.STUnion(@g2).ToString();
insert t1 values(@g1), (@g3)
select id, geom.ToString(), ugeom.ToString() from t1



