
/*
a.	UnionAggregate 
b.	EnvelopeAggregate 
c.	CollectionAggregate 
d.	ConvexHullAggregate 
*/

use SpatialSamples
go

-- All admin regions in Belgium
select * from admin00
  WHERE CNTRY_NAME = 'Belgium';

-- UnionAggregate
SELECT Geography::UnionAggregate(geog) FROM admin00
  WHERE CNTRY_NAME = 'Belgium';

-- All admin regions in Belgium with EnvelopeAggregate
select GEOG from admin00
  WHERE CNTRY_NAME = 'Belgium'
UNION ALL
SELECT Geography::EnvelopeAggregate(geog) FROM admin00
  WHERE CNTRY_NAME = 'Belgium';

-- All admin regions in Belgium with CollectionAggregate
select GEOG, GEOG.STGeometryType() as Type
FROM admin00
  WHERE CNTRY_NAME = 'Belgium';

SELECT Geography::CollectionAggregate(geog) AS Collection,
       Geography::CollectionAggregate(geog).STGeometryType() As Type 
FROM admin00
  WHERE CNTRY_NAME = 'Belgium';

-- All admin regions in Belgium with ConvexHullAggregate
select GEOG from admin00
  WHERE CNTRY_NAME = 'Belgium'
UNION ALL
SELECT Geography::ConvexHullAggregate(geog) FROM admin00
  WHERE CNTRY_NAME = 'Belgium';

